/******************************************************************************** 
    Desarrollado por:   Avanxo México
    Autor:              Héctor Figueroa
    Proyecto:           TOYOTA TAM
    Descripción:        Clase que contiene la logica para procesar los registros del archivo de TAM_CatalogoProductos__c
    					y crea el prducto (Product2), Listas de precios (PriceBook2) 
    					Listas de precios y productos (PriceBooEntry)

    Infomación de cambios (versiones)
    ===============================================================================
    No.    Fecha             Autor                       Descripcion
    1.0    01-Junio-2019     Héctor Figueroa             Creación
    1.0    09-Julio-2019     Héctor Figueroa             Actualización: Se actualiza el objeto: VehiculoSIV__c
    													 paa el proceso de Autos Pool   
******************************************************************************* */

public with sharing class TAM_CatalogoProductos_tgr_handler extends TriggerHandler{

	public Pricebook2 pbStandard;
	public String sIdStdListPrice = '';
	private Map<String, Serie__c> mapSerie {get;set;}	
    private List<TAM_CatalogoProductos__c> itemsNew;	

	//Un constructor por default
	public TAM_CatalogoProductos_tgr_handler() {
        this.itemsNew = (List<TAM_CatalogoProductos__c>) Trigger.new;		
	}

	public class wrpPricebook{
		public String IdExternoListaPrecios {get;set;}		
		public String InicioVigencia {get;set;}
		public String FinVigencia {get;set;}
		public String DivisaPrecio {get;set;}
				
		//Un constructor por default
		public wrpPricebook(){
			this.IdExternoListaPrecios = '';
			this.InicioVigencia = String.valueOf(Date.today());
			this.FinVigencia = String.valueOf(Date.today());
			this.DivisaPrecio = '';
		}
		
		//Un constructor por default
		public wrpPricebook(String IdExternoListaPrecios, String InicioVigencia, String FinVigencia, String DivisaPrecio){
			this.IdExternoListaPrecios = IdExternoListaPrecios;
			this.InicioVigencia = InicioVigencia;
			this.FinVigencia = FinVigencia;
			this.DivisaPrecio = DivisaPrecio;			
		}
	}

	
	public class wrpPricebookEntry{
		
		public Decimal PrecioSinIva {get;set;}		
		public Decimal PrecioPublico {get;set;}
		public Decimal PrecioTotalEmpleado {get;set;}
		public Decimal dMSRP {get;set;}
		public Decimal dTMEX_Margin_P {get;set;}
		public Decimal dTMEX_Margin {get;set;}
		public Decimal dDealer_Margin_P {get;set;}
		public Decimal dDealer_Margin {get;set;}
		public Decimal dMSRP_Employe {get;set;}

		public Decimal dRetailPriceMXP {get;set;}
		public String sTMSMarginUSD {get;set;}
		public String sUSLocalCostsUSD {get;set;}
		public String sTLSMarginUSD {get;set;}
		public Decimal dX100POptionUSD {get;set;}
		public String sPhaseCodeVersion {get;set;}
		public String sTMSMarginP {get;set;}
		public String sInLineAccessoryCostUSD {get;set;}
		public String sVehicleType {get;set;}
		public Decimal dTMSCostUSD {get;set;}
		public Decimal dLandedCostUSD {get;set;}
		public String sOceanFreightUSD {get;set;}
		public String sISANTaxTotalEmployeeMXP {get;set;}
		public Decimal dIVAVATMXP {get;set;}
		public Integer iIVAP {get;set;}
		public Decimal dVehicleExFactoryPriceUSD {get;set;}
		public Decimal dLandedCostMXP {get;set;} 
		public String sInlandFreightUSD {get;set;} 
		public String sOneExFactPriceAdjustmentFactorMXP {get;set;} 
		public String sISANTaxTotalMXP {get;set;} 
		public Decimal dIVAVATEmployeeMXP {get;set;}
		public Integer iMixPercentage {get;set;}
		public Decimal dFreightInsuranceUSD {get;set;}
		public Decimal dMexicoLocalCostsMXP {get;set;}
		public String sMarineInsuranceP {get;set;}
		public String sPDIPDSMXP {get;set;}
		public Decimal dRetailPriceUSD {get;set;}
		
		public String sTransSurveyUSD {get;set;}
		public String sTAM_ModId {get;set;} //Validar
		public Decimal dMarineInsuranceUSD {get;set;}//Validar
		public Decimal dDealerCostUSD {get;set;}//Validar		
		public Decimal dExFactorywFastPricingUSD {get;set;}//Validar
		public Decimal dMSRPwoIVAEmployeeMXP {get;set;}//Validar
		public String sApplicableAmountMXP {get;set;}//Validar
		public Integer iPDIPDSEmployeeMXP {get;set;}//Validar
		public Decimal dMSRPwoIVAISANUSD {get;set;}//Validar
		public Decimal dFixedAmountMXP {get;set;}//Validar
		public Decimal dMSRPwoIVAISANEmployeeMXP {get;set;}//Validar
		public String sProdMth {get;set;} //Validar
		public String sFileName {get;set;} //Validar
		public Decimal dM3USD {get;set;}//Validar
		public Decimal dFreightInsuranceMXP {get;set;}//Validar
		public Integer iIVAPEmployeeMXP {get;set;}//Validar
		public Decimal dCIFtoTMEXMXP {get;set;}//Validar
		public String sModName {get;set;} //Validar
		public Decimal dMSRPwoIVAMXP {get;set;}//Validar
		public Decimal dCIFtoTMEXUSD {get;set;}//Validar
		public Decimal dDealerCostEmployeeMXP {get;set;}//Validar
		public Decimal dMSRPwoIVAISANMXP {get;set;}//Validar
		public String iWharfageANDHandlingUSD {get;set;}//Validar
		public Decimal dDTAP {get;set;}//Validar
		public Decimal dDealerCostMXP {get;set;}//Validar
		public Decimal dAllinrateUSD {get;set;}//Validar
		public Integer iPricingFXRatesMXP {get;set;}//Validar
		public String sSource {get;set;} //Validar
		public Decimal dExFactoryPricewithoptionsUSD {get;set;} //Validar
		public String sDocksidePreparationUSD {get;set;}//Validar
		public Decimal dDTAUSD {get;set;} //Validar
		public Decimal dMSRPUSD {get;set;} //Validar
		public Decimal dFreightInsuranceEmployeeMXP {get;set;} //Validar
		
		public String sCuotaPublicidad {get;set;}//Validar		
		public String sCuotaAsociacionFundacion {get;set;}//Validar		
		
		//Un constructor por default
		public wrpPricebookEntry(){
			this.PrecioSinIva = 0.0;
			this.PrecioPublico = 0.0;
			this.PrecioTotalEmpleado = 0.0;
			this.dMSRP = 0.0;
			this.dTMEX_Margin_P = 0.0;
			this.dTMEX_Margin = 0.0;
			this.dDealer_Margin_P = 0.0;
			this.dDealer_Margin = 0.0;
			this.dMSRP_Employe = 0.0;

			this.dX100POptionUSD = 0.0;
			this.sPhaseCodeVersion = '';
			this.sTMSMarginP = '';
			this.sInLineAccessoryCostUSD = ''; 
			this.sVehicleType = '';
			this.dTMSCostUSD = 0.0;
			this.dLandedCostUSD = 0.0;
			this.sOceanFreightUSD = '';
			this.sISANTaxTotalEmployeeMXP = '';
			this.dIVAVATMXP = 0.0;
			this.iIVAP = 0;
			this.dVehicleExFactoryPriceUSD = 0.0;
			this.dLandedCostMXP =  0.0;
			this.sInlandFreightUSD =  '0.0';
			this.sOneExFactPriceAdjustmentFactorMXP = ''; 
			this.sISANTaxTotalMXP =  '';
			this.dIVAVATEmployeeMXP = 0.0;
			this.iMixPercentage = 0;
			this.dFreightInsuranceUSD = 0.0;
			this.dMexicoLocalCostsMXP = 0.0;
			this.sMarineInsuranceP = '';
			this.sPDIPDSMXP = '';
			this.dRetailPriceUSD = 0.0;
			
			this.sTransSurveyUSD = '0.0';
			this.sTAM_ModId = ''; //Validar
			this.dMarineInsuranceUSD = 0.0;//Validar
			this.dDealerCostUSD = 0.0;//Validar		
			this.dExFactorywFastPricingUSD = 0.0;//Validar
			this.dMSRPwoIVAEmployeeMXP = 0.0;//Validar
			this.sApplicableAmountMXP = '0.0';//Validar
			this.iPDIPDSEmployeeMXP = 0;//Validar
			this.dMSRPwoIVAISANUSD = 0.0;//Validar
			this.dFixedAmountMXP = 0.0;//Validar
			this.dMSRPwoIVAISANEmployeeMXP = 0.0;//Validar
			this.sProdMth = ''; //Validar
			this.sFileName = ''; //Validar
			this.dM3USD = 0.0;//Validar
			this.dFreightInsuranceMXP = 0.0;//Validar
			this.iIVAPEmployeeMXP = 0;//Validar
			this.dCIFtoTMEXMXP = 0.0;//Validar
			this.sModName = ''; //Validar
			this.dMSRPwoIVAMXP = 0.0;//Validar
			this.dCIFtoTMEXUSD = 0.0;//Validar
			this.dDealerCostEmployeeMXP = 0.0;//Validar
			this.dMSRPwoIVAISANMXP = 0.0;//Validar
			this.iWharfageANDHandlingUSD = '0';//Validar
			this.dDTAP = 0.0;//Validar
			this.dDealerCostMXP = 0.0;//Validar
			this.dAllinrateUSD = 0.0;//Validar
			this.iPricingFXRatesMXP = 0;//Validar
			this.sSource = ''; //Validar
			this.dExFactoryPricewithoptionsUSD = 0.0; //Validar
			this.sDocksidePreparationUSD = '0';//Validar
			this.dDTAUSD = 0.0; //Validar
			this.dMSRPUSD = 0.0; //Validar
			this.dFreightInsuranceEmployeeMXP = 0.0; //Validar

			this.sCuotaPublicidad = '0.00'; //Validar		
			this.sCuotaAsociacionFundacion = '0.00'; //Validar			
		}
		
		//Un constructor por default
		public wrpPricebookEntry(Decimal PrecioSinIva, Decimal PrecioPublico, Decimal PrecioTotalEmpleado){
			this.PrecioSinIva = PrecioSinIva;
			this.PrecioPublico = PrecioPublico;
			this.PrecioTotalEmpleado = PrecioTotalEmpleado;
		}
	}
	
	public class wrpProducto{							//Product2					TAM_CatalogoProductos
		public String Name {get;set;}					//Name						Name
		public String IdExterno {get;set;}				//IdExternoProducto__c		IdExterno__c
		public String Serie {get;set;}					//Serie__c					Serie__c
		public String AnioModelo {get;set;}//			//Anio__c					AnioModelo__c
		public String IdExternoListaPrecios {get;set;}	//IdExternoListaPrecios__c 	IdExternoListaPrecios__c
		public String Familia {get;set;}				//Family					Familia__c
		public String Version {get;set;}				//NombreVersion__c			Version__c
				
		//Un constructor por default
		public wrpProducto(){
			this.Name = '';
			this.IdExterno = '';
			this.Serie = '';
			this.AnioModelo = '';
			this.IdExternoListaPrecios = '';
			this.Familia = '';
			this.Version = '';			
		}
		
		//Un constructor por default
		public wrpProducto(String Name, String IdExterno, String Serie, String AnioModelo, 
			String IdExternoListaPrecios, String Familia, String Version){
			this.Name = Name;
			this.IdExterno = IdExterno;
			this.Serie = Serie;
			this.AnioModelo = AnioModelo;
			this.Familia = Familia;
			this.Version = Version;			
		}
	}
	
	//Sobreescribe el metodo de beforeInsert
    public override void beforeInsert() {
		System.debug('EN beforeInsert....');
		creaMapasDatos();
    }

	//Sobreescribe el metodo de beforeUpdate
    public override void beforeUpdate() {
		System.debug('EN beforeUpdate....');
		creaMapasDatos();    	
    }

    //Funcion que sirve para actualizar las listas de precio que se estan crgando en TAM_CatalogoProductos__c
    private void creaMapasDatos(){
		System.debug('EN creaMapasDatos....');
		
		pbStandard = new Pricebook2(); 
		if  (!Test.isRunningTest()){
			pbStandard = [SELECT Id, Name, IdExternoListaPrecios__c FROM Pricebook2 WHERE IdExternoListaPrecios__c='StandardPriceBook'];
			sIdStdListPrice = pbStandard.id;
		} 
		if  (Test.isRunningTest())
			sIdStdListPrice = Test.getStandardPricebookId();
			
		mapSerie = new Map<String, Serie__c>(); 		    
    	Map<String, wrpPricebook> mapWrpPricebook = new Map<String, wrpPricebook>();
    	Map<String, wrpPricebookEntry> mapWrpPricebookEntry = new Map<String, wrpPricebookEntry>();    	
    	Map<String, wrpProducto> mapWrpProducto = new Map<String, wrpProducto>();    	
    	
    	//Llena el mapa de mapSerie
		for (Serie__c objSerie : [SELECT Id, Name, Id_Externo_Serie__c FROM Serie__c]){
			mapSerie.put(objSerie.Name, objSerie);
		}//Fin del for para los datos de la serie
		System.debug('EN beforeInsert mapSerie: ' + mapSerie.KeySet());
		System.debug('EN beforeInsert mapSerie: ' + mapSerie.Values());		
		    	
    	//Muy bien toma todos los reg que se estan insetarndo en bloque y procesalos
    	for (TAM_CatalogoProductos__c objTAM_CatalogoProductos : itemsNew){
			System.debug('EN beforeInsert objTAM_CatalogoProductos: ' + objTAM_CatalogoProductos);
						
			//Ve si el producto tiene los datos que se requieren para la llave externa
			if (objTAM_CatalogoProductos.IdExterno__c != null && objTAM_CatalogoProductos.IdExterno__c != ''){
				
				//Formatea las fechas
				String sInicioVigencia = ConvierteFecha(objTAM_CatalogoProductos.InicioVigencia__c);
				String sFinVigencia = ConvierteFecha(objTAM_CatalogoProductos.FinVigencia__c);
								
				//Agrega el producto al mapa de mapWrpProducto 
				if (!mapWrpProducto.containsKey(objTAM_CatalogoProductos.IdExterno__c)){
					String sSerie = objTAM_CatalogoProductos.Serie__c != null ? objTAM_CatalogoProductos.Serie__c : '';
					sSerie = sSerie.toUpperCase();
					mapWrpProducto.put(objTAM_CatalogoProductos.IdExterno__c, new wrpProducto(
							objTAM_CatalogoProductos.Name,
							objTAM_CatalogoProductos.IdExterno__c,
							sSerie, //objTAM_CatalogoProductos.Serie__c,
							objTAM_CatalogoProductos.AnioModelo__c,
							objTAM_CatalogoProductos.IdExternoListaPrecios__c,
							objTAM_CatalogoProductos.Familia__c != NULL ? objTAM_CatalogoProductos.Familia__c : 'Toyota',
							objTAM_CatalogoProductos.Version__c
						)
					);
				}//Fin si !mapWrpProducto.containsKey(objTAM_CatalogoProductos.IdExterno__c)
	    		
	    		//Crea el reg para la lista de precios 
				if (!mapWrpPricebook.containsKey(objTAM_CatalogoProductos.IdExternoListaPrecios__c)){
					mapWrpPricebook.put(objTAM_CatalogoProductos.IdExternoListaPrecios__c, new wrpPricebook(
							objTAM_CatalogoProductos.IdExternoListaPrecios__c,
							sInicioVigencia, //objTAM_CatalogoProductos.InicioVigencia__c,
							sFinVigencia, //objTAM_CatalogoProductos.FinVigencia__c,
							objTAM_CatalogoProductos.DivisaPrecio__c							
						)
					);
				}//Fin si !mapWrpPricebook.mapWrpPricebook(objTAM_CatalogoProductos.IdExternoListaPrecios__c)				
				System.debug('EN beforeInsert PrecioSinIva__c: ' + objTAM_CatalogoProductos.PrecioSinIva__c + ' PrecioPublico__c: ' + objTAM_CatalogoProductos.PrecioPublico__c + ' PrecioTotalEmpleado__c: ' + objTAM_CatalogoProductos.PrecioTotalEmpleado__c);
					
				String sIdExternoProdIdExtListPrecios = objTAM_CatalogoProductos.IdExterno__c + ',' + objTAM_CatalogoProductos.IdExternoListaPrecios__c;
				String sPrecioSinIva = objTAM_CatalogoProductos.PrecioSinIva__c != null ? objTAM_CatalogoProductos.PrecioSinIva__c : '0.00';
				sPrecioSinIva = sPrecioSinIva.replace(',',''); 
				String sPrecioPublico = objTAM_CatalogoProductos.PrecioPublico__c != null ? objTAM_CatalogoProductos.PrecioPublico__c : '0.00';
				sPrecioPublico = sPrecioPublico.replace(',','');
				String sPrecioTotalEmpleado = objTAM_CatalogoProductos.PrecioTotalEmpleado__c != null ? objTAM_CatalogoProductos.PrecioTotalEmpleado__c : '0.00';
				sPrecioTotalEmpleado = sPrecioTotalEmpleado.replace(',','');
				System.debug('EN beforeInsert sPrecioSinIva: ' + sPrecioSinIva + ' sPrecioPublico: ' + sPrecioPublico + ' sPrecioTotalEmpleado: ' + sPrecioTotalEmpleado);
								
	    		//Crea el reg para la lista de precios 
				if (!mapWrpPricebookEntry.containsKey(sIdExternoProdIdExtListPrecios)){
					wrpPricebookEntry objWrpPricebookEntry = new wrpPricebookEntry(
						Decimal.valueOf(sPrecioSinIva),
						Decimal.valueOf(sPrecioPublico),
						Decimal.valueOf(sPrecioTotalEmpleado)
					);
					//Inicializa el resto de los campos
					objWrpPricebookEntry.dMSRP = objTAM_CatalogoProductos.TAM_MSRP__c;
					objWrpPricebookEntry.dTMEX_Margin_P = objTAM_CatalogoProductos.TAM_MargenesGananciaTMEX_Porc__c;
					objWrpPricebookEntry.dTMEX_Margin = objTAM_CatalogoProductos.TAM_MargenesGananciaTMEX_Pesos__c;
					objWrpPricebookEntry.dDealer_Margin_P = objTAM_CatalogoProductos.TAM_MargenesGananciaDealer_Porc__c;
					objWrpPricebookEntry.dDealer_Margin = objTAM_CatalogoProductos.TAM_MargenesGananciaDealer_Pesos__c;
					objWrpPricebookEntry.dMSRP_Employe = objTAM_CatalogoProductos.TAM_MSRPEmploye__c;
					
					objWrpPricebookEntry.sTransSurveyUSD = objTAM_CatalogoProductos.TAM_TransSurveyUSD__c == '#Missing' ? '0.00' : String.valueOf(objTAM_CatalogoProductos.TAM_TransSurveyUSD__c); //VALIDAR;
					objWrpPricebookEntry.dRetailPriceMXP = objTAM_CatalogoProductos.TAM_RetailPriceMXP__c;
					objWrpPricebookEntry.sTMSMarginUSD = objTAM_CatalogoProductos.TAM_TMSMarginUSD__c == '#Missing' ? '0.00' : String.valueOf(objTAM_CatalogoProductos.TAM_TMSMarginUSD__c); //VALIDAR
					objWrpPricebookEntry.sUSLocalCostsUSD = objTAM_CatalogoProductos.TAM_USLocalCostsUSD__c == '#Missing' ? '0.00' : String.valueOf(objTAM_CatalogoProductos.TAM_USLocalCostsUSD__c); //VALIDAR;
					objWrpPricebookEntry.sTLSMarginUSD = objTAM_CatalogoProductos.TAM_TLSMarginUSD__c != null ? (objTAM_CatalogoProductos.TAM_TLSMarginUSD__c == '#Missing' ? '0.00' : String.valueOf(objTAM_CatalogoProductos.TAM_TLSMarginUSD__c)) : '0.00';
					objWrpPricebookEntry.dX100POptionUSD = objTAM_CatalogoProductos.TAM_X100POptionUSD__c != null ? (objTAM_CatalogoProductos.TAM_X100POptionUSD__c == '#Missing' ? 0.00 : Decimal.valueOf(objTAM_CatalogoProductos.TAM_X100POptionUSD__c)) : 0.00;	
					objWrpPricebookEntry.sPhaseCodeVersion = objTAM_CatalogoProductos.TAM_PhaseCodeVersion__c;	
					objWrpPricebookEntry.sTMSMarginP = objTAM_CatalogoProductos.TAM_TMSMarginP__c == '#Missing' ? '0.00' : String.valueOf(objTAM_CatalogoProductos.TAM_TMSMarginP__c); //VALIDAR 
					objWrpPricebookEntry.sInLineAccessoryCostUSD = objTAM_CatalogoProductos.TAM_InLineAccessoryCostUSD__c == '#Missing' ? '0.00' : String.valueOf(objTAM_CatalogoProductos.TAM_InLineAccessoryCostUSD__c); //VALIDAR 
					objWrpPricebookEntry.sVehicleType = objTAM_CatalogoProductos.TAM_VehicleType__c ;
					objWrpPricebookEntry.dTMSCostUSD = objTAM_CatalogoProductos.TAM_TMSCostUSD__c ;
					objWrpPricebookEntry.dLandedCostUSD = objTAM_CatalogoProductos.TAM_LandedCostUSD__c ;
					//objWrpPricebookEntry.PrecioSinIva = objTAM_CatalogoProductos.PrecioSinIva__c ;
					objWrpPricebookEntry.sOceanFreightUSD = objTAM_CatalogoProductos.TAM_OceanFreightUSD__c  == '#Missing' ? '0.00' : String.valueOf(objTAM_CatalogoProductos.TAM_OceanFreightUSD__c); //VALIDAR
					objWrpPricebookEntry.sISANTaxTotalEmployeeMXP = objTAM_CatalogoProductos.TAM_ISANTaxTotalEmployeeMXP__c  == '#Missing' ? '0.00' : String.valueOf(objTAM_CatalogoProductos.TAM_ISANTaxTotalEmployeeMXP__c); //VALIDAR 
					objWrpPricebookEntry.dIVAVATMXP = objTAM_CatalogoProductos.TAM_IVAVATMXP__c ;
					objWrpPricebookEntry.iIVAP = Integer.valueOf(objTAM_CatalogoProductos.TAM_IVAP__c) ;
					objWrpPricebookEntry.dVehicleExFactoryPriceUSD = objTAM_CatalogoProductos.TAM_VehicleExFactoryPriceUSD__c ;
					objWrpPricebookEntry.dLandedCostMXP = objTAM_CatalogoProductos.TAM_LandedCostMXP__c ;
					objWrpPricebookEntry.sInlandFreightUSD = objTAM_CatalogoProductos.TAM_InlandFreightUSD__c == '#Missing' ? '0.00' : String.valueOf(objTAM_CatalogoProductos.TAM_InlandFreightUSD__c); //VALIDAR ;
					objWrpPricebookEntry.sOneExFactPriceAdjustmentFactorMXP = objTAM_CatalogoProductos.TAM_OneExFactPriceAdjustmentFactorMXP__c == '#Missing' ? '0.00' : String.valueOf(objTAM_CatalogoProductos.TAM_OneExFactPriceAdjustmentFactorMXP__c); //VALIDAR 
					objWrpPricebookEntry.sISANTaxTotalMXP = objTAM_CatalogoProductos.TAM_ISANTaxTotalMXP__c == '#Missing' ? '0.00' : String.valueOf(objTAM_CatalogoProductos.TAM_ISANTaxTotalMXP__c); //VALIDAR 
					objWrpPricebookEntry.dIVAVATEmployeeMXP = objTAM_CatalogoProductos.TAM_IVAVATEmployeeMXP__c ;
					objWrpPricebookEntry.iMixPercentage = Integer.valueOf(objTAM_CatalogoProductos.TAM_MixPercentage__c) ;
					objWrpPricebookEntry.dFreightInsuranceUSD = objTAM_CatalogoProductos.TAM_FreightInsuranceUSD__c ;
					objWrpPricebookEntry.dMexicoLocalCostsMXP = objTAM_CatalogoProductos.TAM_MexicoLocalCostsMXP__c ;
					objWrpPricebookEntry.sMarineInsuranceP = objTAM_CatalogoProductos.TAM_MarineInsuranceP__c == '#Missing' ? '0.00' : String.valueOf(objTAM_CatalogoProductos.TAM_MarineInsuranceP__c); //VALIDAR 
					objWrpPricebookEntry.sPDIPDSMXP = objTAM_CatalogoProductos.TAM_PDIPDSMXP__c ;
					objWrpPricebookEntry.dRetailPriceUSD = objTAM_CatalogoProductos.TAM_RetailPriceUSD__c ;
					
					//Para el registro relaciopado
					objWrpPricebookEntry.sTAM_ModId = objTAM_CatalogoProductos.TAM_ModId__c ;
					objWrpPricebookEntry.dMarineInsuranceUSD = objTAM_CatalogoProductos.TAM_MarineInsuranceUSD__c != null ? (objTAM_CatalogoProductos.TAM_MarineInsuranceUSD__c == '#Missing' ? 0.00 : Decimal.valueOf(objTAM_CatalogoProductos.TAM_MarineInsuranceUSD__c)) : 0.00; //VALIDAR
					objWrpPricebookEntry.dDealerCostUSD = objTAM_CatalogoProductos.TAM_DealerCostUSD__c ;										
					objWrpPricebookEntry.dExFactorywFastPricingUSD = objTAM_CatalogoProductos.TAM_ExFactorywFastPricingUSD__c ;
					objWrpPricebookEntry.dMSRPwoIVAEmployeeMXP = objTAM_CatalogoProductos.TAM_MSRPwoIVAEmployeeMXP__c ;
					objWrpPricebookEntry.sApplicableAmountMXP = objTAM_CatalogoProductos.TAM_ApplicableAmountMXP__c== '#Missing' ? '0.00' : String.valueOf(objTAM_CatalogoProductos.TAM_ApplicableAmountMXP__c);	//vALIDAR					
					objWrpPricebookEntry.iPDIPDSEmployeeMXP = Integer.valueOf(objTAM_CatalogoProductos.TAM_PDIPDSEmployeeMXP__c) ;	
					objWrpPricebookEntry.dMSRPwoIVAISANUSD = objTAM_CatalogoProductos.TAM_MSRPwoIVAISANUSD__c ;	
					objWrpPricebookEntry.dFixedAmountMXP = objTAM_CatalogoProductos.TAM_FixedAmountMXP__c != null ? (objTAM_CatalogoProductos.TAM_FixedAmountMXP__c == '#Missing' ? 0.00 : Decimal.valueOf(objTAM_CatalogoProductos.TAM_FixedAmountMXP__c)) : 0.00;	//vALIDAR
					objWrpPricebookEntry.dMSRPwoIVAISANEmployeeMXP = objTAM_CatalogoProductos.TAM_MSRPwoIVAISANEmployeeMXP__c ;	
					objWrpPricebookEntry.sProdMth = objTAM_CatalogoProductos.TAM_ProdMth__c ;	
					objWrpPricebookEntry.sFileName = objTAM_CatalogoProductos.TAM_FileName__c ;	
					objWrpPricebookEntry.dM3USD = objTAM_CatalogoProductos.TAM_M3USD__c != null ? (objTAM_CatalogoProductos.TAM_M3USD__c == '#Missing' ? 0.00 : Decimal.valueOf(objTAM_CatalogoProductos.TAM_M3USD__c)) : 0.00; //VALIDAR 
					objWrpPricebookEntry.dFreightInsuranceMXP = objTAM_CatalogoProductos.TAM_FreightInsuranceMXP__c ;
					objWrpPricebookEntry.iIVAPEmployeeMXP = objTAM_CatalogoProductos.TAM_IVAPEmployeeMXP__c != null ? (objTAM_CatalogoProductos.TAM_IVAPEmployeeMXP__c == '#Missing' ? 0 : Integer.valueOf(objTAM_CatalogoProductos.TAM_IVAPEmployeeMXP__c)) : 0; //VALIDAR 
					objWrpPricebookEntry.dCIFtoTMEXMXP = objTAM_CatalogoProductos.TAM_CIFtoTMEXMXP__c ;
					objWrpPricebookEntry.sModName = objTAM_CatalogoProductos.TAM_ModName__c ;
					objWrpPricebookEntry.dMSRPwoIVAMXP = objTAM_CatalogoProductos.TAM_MSRPwoIVAMXP__c ;
					objWrpPricebookEntry.dCIFtoTMEXUSD = objTAM_CatalogoProductos.TAM_CIFtoTMEXUSD__c ;
					objWrpPricebookEntry.dDealerCostEmployeeMXP = objTAM_CatalogoProductos.TAM_DealerCostEmployeeMXP__c ;
					objWrpPricebookEntry.dMSRPwoIVAISANMXP = objTAM_CatalogoProductos.TAM_MSRPwoIVAISANMXP__c ;
					objWrpPricebookEntry.iWharfageANDHandlingUSD = objTAM_CatalogoProductos.TAM_WharfageANDHandlingUSD__c == '#Missing' ? '0.00' : String.valueOf(objTAM_CatalogoProductos.TAM_WharfageANDHandlingUSD__c); //VALIDAR
					objWrpPricebookEntry.dDTAP = objTAM_CatalogoProductos.TAM_DTAP__c != null ? (objTAM_CatalogoProductos.TAM_DTAP__c == '#Missing' ? 0.00 : Decimal.valueOf(objTAM_CatalogoProductos.TAM_DTAP__c)) : 0.00; //VALIDAR
					objWrpPricebookEntry.dDealerCostMXP = objTAM_CatalogoProductos.TAM_DealerCostMXP__c ;
					
					objWrpPricebookEntry.dAllinrateUSD = objTAM_CatalogoProductos.TAM_AllinrateUSD__c != null ? (objTAM_CatalogoProductos.TAM_AllinrateUSD__c == '#Missing' ? 0.00 : Decimal.valueOf(objTAM_CatalogoProductos.TAM_AllinrateUSD__c)) : 0.00; //VALIDAR 
					objWrpPricebookEntry.iPricingFXRatesMXP = Integer.valueOf(objTAM_CatalogoProductos.TAM_PricingFXRatesMXP__c) ;
					objWrpPricebookEntry.sSource = objTAM_CatalogoProductos.TAM_Source__c ;
					objWrpPricebookEntry.dExFactoryPricewithoptionsUSD = objTAM_CatalogoProductos.TAM_ExFactoryPricewithoptionsUSD__c ;
					objWrpPricebookEntry.sDocksidePreparationUSD = objTAM_CatalogoProductos.TAM_DocksidePreparationUSD__c == '#Missing' ? '0.00' : String.valueOf(objTAM_CatalogoProductos.TAM_DocksidePreparationUSD__c); //VALIDAR 
					objWrpPricebookEntry.dDTAUSD = objTAM_CatalogoProductos.TAM_DTAUSD__c != null ? (objTAM_CatalogoProductos.TAM_DTAUSD__c == '#Missing' ? 0.00 : Decimal.valueOf(objTAM_CatalogoProductos.TAM_DTAUSD__c)) : 0.00; //VALIDAR 
					objWrpPricebookEntry.dMSRPUSD = objTAM_CatalogoProductos.TAM_MSRPUSD__c ;
					objWrpPricebookEntry.dFreightInsuranceEmployeeMXP = objTAM_CatalogoProductos.TAM_FreightInsuranceEmployeeMXP__c ;

					objWrpPricebookEntry.sCuotaPublicidad = objTAM_CatalogoProductos.TAM_CuotaPublicidad__c == '#Missing' ? '0.00' : String.valueOf(objTAM_CatalogoProductos.TAM_CuotaPublicidad__c); //VALIDAR 
					objWrpPricebookEntry.sCuotaAsociacionFundacion = objTAM_CatalogoProductos.TAM_CuotaAsociacionFundacion__c == '#Missing' ? '0.00' : String.valueOf(objTAM_CatalogoProductos.TAM_CuotaAsociacionFundacion__c); //VALIDAR 

					System.debug('EN beforeInsert.creaMapasDatos objWrpPricebookEntry: ' + objWrpPricebookEntry);
					
					//Agregalo al mapa de mapWrpPricebookEntry   
					mapWrpPricebookEntry.put(sIdExternoProdIdExtListPrecios, objWrpPricebookEntry);
				}//Fin si !mapWrpPricebook.mapWrpPricebook(objTAM_CatalogoProductos.IdExternoListaPrecios__c)
    		
			}//Fin si objTAM_CatalogoProductos.IdExterno__c != null && objTAM_CatalogoProductos.IdExterno__c != ''
			
    	}//Fin del for para los tregistros de itemsNew
    	
    	//Ya tienes los datos para crear los reg manda llamar la funcion de actualizaListasPrecios
    	actualizaListaPrecios(mapWrpPricebook, mapWrpProducto, mapWrpPricebookEntry, mapSerie, itemsNew);    
    	
    }
	

    //Funcion que sirve para actualizar las listas de precio que se estan crgando en TAM_CatalogoProductos__c
    private void actualizaListaPrecios(Map<String, wrpPricebook> mapWrpPricebook, Map<String, wrpProducto> mapWrpProducto, 
    	Map<String, wrpPricebookEntry> mapWrpPricebookEntry, Map<String, Serie__c> mapSerie, List<TAM_CatalogoProductos__c> itemsNew){
		System.debug('EN actualizaListaPrecios....');    		
		String VaRtProducto = Schema.SObjectType.Product2.getRecordTypeInfosByName().get('Unidad').getRecordTypeId();
    	
    	Map<String, Pricebook2> mapPricebook2Ups = new Map<String, Pricebook2>();
    	Map<String, Pricebook2> mapPricebook2Fin = new Map<String, Pricebook2>();    	
    	Set<String> setIdPricebookUps = new Set<String>();
    	Map<String, Product2> mapProduct2Ups = new Map<String, Product2>();
    	Map<String, Product2> mapProduct2Fin = new Map<String, Product2>();    	
    	Set<String> setIdProduct2Ups = new Set<String>();    	
    	Map<String, String> mapPricebookEntryStdExist = new Map<String, String>();
    	Map<String, PricebookEntry> mapPricebookEntryStd = new Map<String, PricebookEntry>();
    	Map<String, String> mapPricebookEntryUpsExist = new Map<String, String>();    	    	    	
    	Map<String, PricebookEntry> mapPricebookEntryUps = new Map<String, PricebookEntry>();
    	
    	Map<String, TAM_CamposRelEntradaListaPrecios__c> mapCampRelPricebookEntryPaso = new Map<String, TAM_CamposRelEntradaListaPrecios__c>();
    	Map<String, TAM_CamposRelEntradaListaPrecios__c> mapCampRelPricebookEntryUps = new Map<String, TAM_CamposRelEntradaListaPrecios__c>();
    	
    	Map<String, String> mapPricebookEntryFin = new Map<String, String>();
    	Map<String, VehiculoSIV__c> mapVehiculoSIV = new Map<String, VehiculoSIV__c>();
    	
		Map<String, CapturaIVA__c> mapCapturaIVA = new Map<String, CapturaIVA__c>();    	
    	Map<String, TAM_IvaAplicadoVehiculos__c> mapTAMIvaAplicadoVehiculos = new Map<String, TAM_IvaAplicadoVehiculos__c>();    
    	
    	//Consulta los datos de los IVAS APLICABLES de CapturaIVA__c
    	for (CapturaIVA__c objCapturaIVA : [ Select c.Name, c.IVA__c, c.Fechainicio__c, c.Fechafinvigencia__c, c.ActivoIVA__c 
    		From CapturaIVA__c c]){
    		mapCapturaIVA.put(objCapturaIVA.Name, objCapturaIVA);
    	}//Fin del for para el Iva
    	    	    	    	     		
		//Crea un sp pra hacer el rollback en caso de error
		SavePoint sp = Database.setSavepoint();    	    	     		

		try{
			    	    	     		
	    	//Recorre la lista de precios que viene en la mapa de mapWrpPricebook
	    	for (String sWrpPricebook : mapWrpPricebook.KeySet()){
	    		//Agrela los datos de la lista de precios al mapa de mapPricebook2Ups
	    		mapPricebook2Ups.put(sWrpPricebook, new Pricebook2(
	    				IdExternoListaPrecios__c = sWrpPricebook,
	    				Name = sWrpPricebook,
	    				Description = sWrpPricebook,
	    				InicioVigencia__c = Date.valueOf(mapWrpPricebook.get(sWrpPricebook).InicioVigencia),
	    				FinVigencia__c = Date.valueOf(mapWrpPricebook.get(sWrpPricebook).FinVigencia),
	    				DivisaPrecio__c = mapWrpPricebook.get(sWrpPricebook).DivisaPrecio,
	    				IsActive = true
	    			)
	    		);
	    	}//Fin del for para sWrpPricebook
			System.debug('EN actualizaListaPrecios mapPricebook2Ups.KaySet(): ' + mapPricebook2Ups.KeySet());
			System.debug('EN actualizaListaPrecios mapPricebook2Ups.Values(): ' + mapPricebook2Ups.Values());
						    	
	    	//Muy bien ve si tiene algo mapPricebook2Ups y actualiza los datos de la lista de precio
	    	if (!mapPricebook2Ups.isEmpty()){
	    		List<Database.UpsertResult> lDtbUpsRes = Database.upsert(mapPricebook2Ups.values(), Pricebook2.IdExternoListaPrecios__c, false);
	    		//Ve si hubo errores
	    		for (Database.UpsertResult objDtbUpsRes : lDtbUpsRes){
	    			if (!objDtbUpsRes.isSuccess())
	    				System.debug('Error a la hora de actualizar las listas de precios: ' + objDtbUpsRes.getErrors()[0].getMessage());
	    			if (objDtbUpsRes.isSuccess())
	    				setIdPricebookUps.add(objDtbUpsRes.getId());
	    		}//Fin del for para lDtbUpsRes
				System.debug('La lista de las listas de precios: ' + mapPricebook2Ups.values());    		
	    	} //Fin si !mapPricebook2Ups.isEmpty()
			//Consulta las listas de precios actualizadas
			for (Pricebook2 objListaPrecio : [ Select ID, IdExternoListaPrecios__c From Pricebook2 Where id IN: setIdPricebookUps]){
				mapPricebook2Fin.put(objListaPrecio.IdExternoListaPrecios__c, objListaPrecio);
			}
			System.debug('El mapa final de las listas de precios mapPricebook2Fin: ' + mapPricebook2Fin);

			//Consulta los productos que ya existen a partir del IdExternoProducto__c
			for (Product2 objProduct2 : [Select id, IdExternoProducto__c From Product2 Where IdExternoProducto__c IN : mapWrpProducto.KeySet()]){
				mapProduct2Fin.put(objProduct2.IdExternoProducto__c, objProduct2);			
			}
			System.debug('Los productos del mapa mapProduct2Fin: ' + mapProduct2Fin);
			
	    	//Recorre la lista de precios que viene en la mapa de mapWrpPricebook
	    	for (String sWrpProducto : mapWrpProducto.KeySet()){
	    		//Ve si no existe este producto en mapProduct2Fin
	    		if (!mapProduct2Fin.containsKey(sWrpProducto)){
		    		//Agrela los datos de la lista de precios al mapa de mapPricebook2Ups
		    		mapProduct2Ups.put(sWrpProducto, new Product2(
		    				IdExternoProducto__c = sWrpProducto,									//IdExterno
		    				Name = mapWrpProducto.get(sWrpProducto).Name,							//Name
		    				Description = sWrpProducto + '-' + mapWrpProducto.get(sWrpProducto).Familia + '-' + mapWrpProducto.get(sWrpProducto).Serie + '-' + mapWrpProducto.get(sWrpProducto).Version,	//IdExterno + '' + Familia__c + ' ' +  mapWrpProducto.get(sWrpProducto).Serie + ' ' + 
		    				Anio__c = mapWrpProducto.get(sWrpProducto).AnioModelo,					//AnioModelo__c
		    				SerieModelo__c = mapWrpProducto.get(sWrpProducto).Serie,				//Serie__c
		    				Serie__c = mapSerie.containsKey(mapWrpProducto.get(sWrpProducto).Serie) ? mapSerie.get(mapWrpProducto.get(sWrpProducto).Serie).id : null,
		    				ProductCode = sWrpProducto,												//IdExterno
		    				NombreVersion__c = mapWrpProducto.get(sWrpProducto).Version,			//Version__c
		    				Family = mapWrpProducto.get(sWrpProducto).Familia,						//Familia__c
		    				IsActive = true,
		    				RecordTypeId = VaRtProducto
		    			)
		    		);
	    		}//Fin si !mapProduct2Fin.containsKey(sWrpProducto)	    		
	    	}//Fin del for para sWrpPricebook
			System.debug('El mapa final de las listas de precios mapProduct2Ups: ' + mapProduct2Ups.KeySet());
			System.debug('El mapa final de las listas de precios mapProduct2Ups: ' + mapProduct2Ups.Values());
							    	
	    	//Muy bien ve si tiene algo mapWrpProducto y actualiza los datos de los productos
	    	if (!mapProduct2Ups.isEmpty()){
	    		List<Database.UpsertResult> lDtbUpsRes = Database.upsert(mapProduct2Ups.values(), Product2.IdExternoProducto__c, false);
	    		//Ve si hubo errores
	    		for (Database.UpsertResult objDtbUpsRes : lDtbUpsRes){
	    			if (!objDtbUpsRes.isSuccess())
	    				System.debug('Error a la hora de actualizar el producto: ' + objDtbUpsRes.getErrors()[0].getMessage());
	    			if (objDtbUpsRes.isSuccess())
	    				setIdProduct2Ups.add(objDtbUpsRes.getId());    				
	    		}//Fin del for para lDtbUpsRes
				System.debug('Los productos: ' + mapProduct2Ups.values());    		
	    	} //Fin si !mapWrpProducto.isEmpty()
			//Conslta la lista de los productos creados actualizados 
			for (Product2 objProduct2 : [Select id, IdExternoProducto__c From Product2 Where id IN : setIdProduct2Ups]){
				mapProduct2Fin.put(objProduct2.IdExternoProducto__c, objProduct2);			
			}
			System.debug('Los productos del mapa mapProduct2Fin2: ' + mapProduct2Fin);
	
	    	//Crea la relación con PricebookEntry de los productos y la lista de precios
	    	for (String sWrpPricebookEntry : mapWrpPricebookEntry.KeySet()){
	    		//Destripa el sWrpPricebookEntry y obten los datos del producto y la lista de precios
	    		String[] lWrpPricebookEntry = sWrpPricebookEntry.split(',');   
				System.debug('En mapWrpPricebookEntry IdProducto: ' + lWrpPricebookEntry.get(0));
				System.debug('En mapWrpPricebookEntry IdListaPrecios: ' + lWrpPricebookEntry.get(1));
				System.debug('En mapWrpPricebookEntry mapProduct2Fin: ' + (mapProduct2Fin.containsKey(lWrpPricebookEntry.get(0))) + ' mapPricebook2Fin: ' + mapPricebook2Fin.containsKey(lWrpPricebookEntry.get(1)) );
								
				//Ve si existe el id del prducto en mapProduct2Fin y la lista de precios en mapPricebook2Fin
				if ( mapProduct2Fin.containsKey(lWrpPricebookEntry.get(0)) && mapPricebook2Fin.containsKey(lWrpPricebookEntry.get(1)) ){
					String sNomListStd = !Test.isRunningTest() ? pbStandard.Name.replace(' ', '') : '';										
					String sIdProdIdStdListPrice = lWrpPricebookEntry.get(0) + '-' + sNomListStd; 
					System.debug('En mapWrpPricebookEntry sIdProdIdStdListPrice: ' + sIdProdIdStdListPrice);
					//Agregalo al mapa me mapPricebookEntryStdExist
					mapPricebookEntryStdExist.put(sIdProdIdStdListPrice, null);
					String sIdProdIdCustListPrice = lWrpPricebookEntry.get(0) + '-' + lWrpPricebookEntry.get(1);
					System.debug('En mapWrpPricebookEntry sIdProdIdCustListPrice: ' + sIdProdIdCustListPrice);
					//Agregalo al mapa me mapPricebookEntryUpsExist
					mapPricebookEntryUpsExist.put(sIdProdIdCustListPrice, null);
				}//Fin si mapProduct2Fin.containsKey(lWrpPricebookEntry.get(0)) && mapPricebook2Fin.containsKey(lWrpPricebookEntry.get(1))
	    	}//Fin del for para sWrpPricebook

			//Consulta en el objeto de PricebookEntry los reg que vienen en mapPricebookEntryStdExist y   
			for (PricebookEntry objPricebookEntry : [Select id, IdExterno__c From PricebookEntry
				Where IdExterno__c IN : mapPricebookEntryStdExist.KeySet() OR IdExterno__c IN : mapPricebookEntryUpsExist.KeySet()]){
				mapPricebookEntryFin.put(objPricebookEntry.IdExterno__c, objPricebookEntry.id);
			}
			System.debug('En mapWrpPricebookEntry mapPricebookEntryFin.KeySet: ' + mapPricebookEntryFin.KeySet());
			System.debug('En mapWrpPricebookEntry mapPricebookEntryFin.Values: ' + mapPricebookEntryFin.Values());
				
	    	//Crea la relación con PricebookEntry de los productos y la lista de precios
	    	for (String sWrpPricebookEntry : mapWrpPricebookEntry.KeySet()){
	    		//Destripa el sWrpPricebookEntry y obten los datos del producto y la lista de precios
	    		String[] lWrpPricebookEntry = sWrpPricebookEntry.split(',');   
				System.debug('En mapWrpPricebookEntry IdProducto: ' + lWrpPricebookEntry.get(0));
				System.debug('En mapWrpPricebookEntry IdListaPrecios: ' + lWrpPricebookEntry.get(1));
				//Ve si existe el id del prducto en mapProduct2Fin y la lista de precios en mapPricebook2Fin
				if (mapProduct2Fin.containsKey(lWrpPricebookEntry.get(0)) && mapPricebook2Fin.containsKey(lWrpPricebookEntry.get(1))){
					String sNomListStd = !Test.isRunningTest() ? pbStandard.Name.replace(' ', '') : '';										
					String sIdProdIdStdListPrice = lWrpPricebookEntry.get(0) + '-' + sNomListStd; 
					System.debug('En mapWrpPricebookEntry sIdProdIdStdListPrice: ' + sIdProdIdStdListPrice); 
					//Para la lista de precios estandard
					PricebookEntry objPricebookEntry;
					TAM_CamposRelEntradaListaPrecios__c objTAMCamposRelEntradaListaPrecios = new TAM_CamposRelEntradaListaPrecios__c();
					
					//Ve si exite el ID externo en mapPricebookEntryFin
					if (mapPricebookEntryFin.containsKey(sIdProdIdStdListPrice))
						objPricebookEntry = new PricebookEntry(id = mapPricebookEntryFin.get(sIdProdIdStdListPrice));
					if (!mapPricebookEntryFin.containsKey(sIdProdIdStdListPrice))
						objPricebookEntry = new PricebookEntry(IdExterno__c = sIdProdIdStdListPrice);
					//Termina de inicializar los campos
					if (!mapPricebookEntryFin.containsKey(sIdProdIdStdListPrice)){					
						objPricebookEntry.Pricebook2Id = sIdStdListPrice;
						objPricebookEntry.Product2Id = mapProduct2Fin.get(lWrpPricebookEntry.get(0)).id;
					}					

					//Calcula el precio sin iva
					objPricebookEntry.PrecioPublico__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).PrecioPublico;
					Decimal dPrecioSinIvaPaso = objPricebookEntry.PrecioPublico__c * .16;
					Decimal dPrecioSinIvaFinal = objPricebookEntry.PrecioPublico__c - dPrecioSinIvaPaso;
					objPricebookEntry.UnitPrice = mapWrpPricebookEntry.get(sWrpPricebookEntry).PrecioSinIva == 0 ? mapWrpPricebookEntry.get(sWrpPricebookEntry).PrecioPublico : mapWrpPricebookEntry.get(sWrpPricebookEntry).PrecioSinIva;
					objPricebookEntry.PrecioSinIva__c = dPrecioSinIvaFinal;
					objPricebookEntry.PrecioTotalEmpleado__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).PrecioTotalEmpleado;	
					objPricebookEntry.IsActive = true;
					
					//Inicializa el resto de los campos
					objPricebookEntry.TAM_MSRP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dMSRP;
					objPricebookEntry.TAM_MargenesGananciaTMEX_Porc__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dTMEX_Margin_P;
					objPricebookEntry.TAM_MargenesGananciaTMEX_Pesos__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dTMEX_Margin;
					objPricebookEntry.TAM_MargenesGananciaDealer_Porc__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dDealer_Margin_P;
					objPricebookEntry.TAM_MargenesGananciaDealer_Pesos__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dDealer_Margin;
					objPricebookEntry.TAM_MSRPEmploye__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dMSRP_Employe;
					
					//Los nuevos campos que se agregaron a objPricebookEntry
					objPricebookEntry.TAM_TransSurveyUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sTransSurveyUSD == null ? 0.00 : Decimal.valueOf(mapWrpPricebookEntry.get(sWrpPricebookEntry).sTransSurveyUSD); //VALIDAR ;	
					objPricebookEntry.TAM_RetailPriceMXP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dRetailPriceMXP;
					objPricebookEntry.TAM_TMSMarginUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sTMSMarginUSD;
					objPricebookEntry.TAM_USLocalCostsUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sUSLocalCostsUSD == null ? 0.00 : Decimal.valueOf(mapWrpPricebookEntry.get(sWrpPricebookEntry).sUSLocalCostsUSD); //VALIDAR;
					objPricebookEntry.TAM_TLSMarginUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sTLSMarginUSD == null ? 0.00 : Decimal.valueOf(mapWrpPricebookEntry.get(sWrpPricebookEntry).sTLSMarginUSD); //VALIDAR;	;				
					objPricebookEntry.TAM_X100POptionUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dX100POptionUSD == null ? 0.00 : mapWrpPricebookEntry.get(sWrpPricebookEntry).dX100POptionUSD; //VALIDAR;	
					objPricebookEntry.TAM_PhaseCodeVersion__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sPhaseCodeVersion == null ? '' : String.valueOf(mapWrpPricebookEntry.get(sWrpPricebookEntry).sPhaseCodeVersion); //VALIDAR ;	
					objPricebookEntry.TAM_TMSMarginP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sTMSMarginP;
					objPricebookEntry.TAM_InLineAccessoryCostUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sInLineAccessoryCostUSD;
					objPricebookEntry.TAM_VehicleType__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sVehicleType;
					objPricebookEntry.TAM_TMSCostUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dTMSCostUSD;
					objPricebookEntry.TAM_LandedCostUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dLandedCostUSD;
					objPricebookEntry.PrecioSinIva__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).PrecioSinIva;
					objPricebookEntry.TAM_OceanFreightUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sOceanFreightUSD;
					objPricebookEntry.TAM_ISANTaxTotalEmployeeMXP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sISANTaxTotalEmployeeMXP;
					objPricebookEntry.TAM_IVAVATMXP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dIVAVATMXP;
					objPricebookEntry.TAM_IVAP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).iIVAP;
					objPricebookEntry.TAM_VehicleExFactoryPriceUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dVehicleExFactoryPriceUSD;
					objPricebookEntry.TAM_LandedCostMXP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dLandedCostMXP;
					objPricebookEntry.TAM_InlandFreightUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sInlandFreightUSD == null ? 0.00 : Decimal.valueOf(mapWrpPricebookEntry.get(sWrpPricebookEntry).sInlandFreightUSD); //VALIDAR;	;				
					objPricebookEntry.TAM_OneExFactPriceAdjustmentFactorMXP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sOneExFactPriceAdjustmentFactorMXP;
					objPricebookEntry.TAM_ISANTaxTotalMXP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sISANTaxTotalMXP;
					objPricebookEntry.TAM_IVAVATEmployeeMXP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dIVAVATEmployeeMXP;
					objPricebookEntry.TAM_MixPercentage__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).iMixPercentage;
					objPricebookEntry.TAM_FreightInsuranceUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dFreightInsuranceUSD;
					objPricebookEntry.TAM_MexicoLocalCostsMXP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dMexicoLocalCostsMXP;
					objPricebookEntry.TAM_MarineInsuranceP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sMarineInsuranceP;
					objPricebookEntry.TAM_PDIPDSMXP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sPDIPDSMXP;
					objPricebookEntry.TAM_RetailPriceUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dRetailPriceUSD;

					//Agregalo al mapa de mapPricebookEntryStd
					mapPricebookEntryStd.put(sIdProdIdStdListPrice, objPricebookEntry);

					//Para la lista de precios customizada
					String sIdProdIdCustListPrice = lWrpPricebookEntry.get(0) + '-' + lWrpPricebookEntry.get(1);
					PricebookEntry objPricebookEntryCust;
					//Ve si exite el ID externo en mapPricebookEntryFin
					if (mapPricebookEntryFin.containsKey(sIdProdIdCustListPrice))
						objPricebookEntryCust = new PricebookEntry(id = mapPricebookEntryFin.get(sIdProdIdCustListPrice));
					if (!mapPricebookEntryFin.containsKey(sIdProdIdCustListPrice))
						objPricebookEntryCust = new PricebookEntry(IdExterno__c = sIdProdIdCustListPrice);
					//Termina de inicializar los campos						
					if (!mapPricebookEntryFin.containsKey(sIdProdIdCustListPrice)){						
						objPricebookEntryCust.Pricebook2Id = mapPricebook2Fin.get(lWrpPricebookEntry.get(1)).id;
						objPricebookEntryCust.Product2Id = mapProduct2Fin.get(lWrpPricebookEntry.get(0)).id;
					}
					
					//Calcula el precio sin iva
					objPricebookEntryCust.PrecioPublico__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).PrecioPublico;
					dPrecioSinIvaPaso = objPricebookEntryCust.PrecioPublico__c * .16;
					dPrecioSinIvaFinal = objPricebookEntryCust.PrecioPublico__c - dPrecioSinIvaPaso;
					objPricebookEntryCust.UnitPrice = mapWrpPricebookEntry.get(sWrpPricebookEntry).PrecioSinIva == 0 ? mapWrpPricebookEntry.get(sWrpPricebookEntry).PrecioPublico : mapWrpPricebookEntry.get(sWrpPricebookEntry).PrecioSinIva;
					objPricebookEntryCust.PrecioSinIva__c = dPrecioSinIvaFinal;
					objPricebookEntryCust.PrecioTotalEmpleado__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).PrecioTotalEmpleado;	
					objPricebookEntryCust.IsActive = true;
					
					//Inicializa el resto de los campos
					objPricebookEntryCust.TAM_MSRP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dMSRP;
					objPricebookEntryCust.TAM_MargenesGananciaTMEX_Porc__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dTMEX_Margin_P;
					objPricebookEntryCust.TAM_MargenesGananciaTMEX_Pesos__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dTMEX_Margin;
					objPricebookEntryCust.TAM_MargenesGananciaDealer_Porc__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dDealer_Margin_P;
					objPricebookEntryCust.TAM_MargenesGananciaDealer_Pesos__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dDealer_Margin;
					objPricebookEntryCust.TAM_MSRPEmploye__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dMSRP_Employe;
					
					//Los nuevos campos que se agregaron a objPricebookEntryCust
					objPricebookEntryCust.TAM_TransSurveyUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sTransSurveyUSD == null ? 0.00 : Decimal.valueOf(mapWrpPricebookEntry.get(sWrpPricebookEntry).sTransSurveyUSD); //VALIDAR ;	
					objPricebookEntryCust.TAM_RetailPriceMXP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dRetailPriceMXP;
					objPricebookEntryCust.TAM_TMSMarginUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sTMSMarginUSD;
					objPricebookEntryCust.TAM_USLocalCostsUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sUSLocalCostsUSD == null ? 0.00 : Decimal.valueOf(mapWrpPricebookEntry.get(sWrpPricebookEntry).sUSLocalCostsUSD); //VALIDAR;
					objPricebookEntryCust.TAM_TLSMarginUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sTLSMarginUSD == null ? 0.00 : Decimal.valueOf(mapWrpPricebookEntry.get(sWrpPricebookEntry).sTLSMarginUSD); //VALIDAR;	;				
					objPricebookEntryCust.TAM_X100POptionUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dX100POptionUSD == null ? 0.00 : mapWrpPricebookEntry.get(sWrpPricebookEntry).dX100POptionUSD; //VALIDAR;	
					objPricebookEntryCust.TAM_PhaseCodeVersion__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sPhaseCodeVersion == null ? '' : String.valueOf(mapWrpPricebookEntry.get(sWrpPricebookEntry).sPhaseCodeVersion); //VALIDAR ;	
					objPricebookEntryCust.TAM_TMSMarginP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sTMSMarginP;
					objPricebookEntryCust.TAM_InLineAccessoryCostUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sInLineAccessoryCostUSD;
					objPricebookEntryCust.TAM_VehicleType__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sVehicleType;
					objPricebookEntryCust.TAM_TMSCostUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dTMSCostUSD;
					objPricebookEntryCust.TAM_LandedCostUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dLandedCostUSD;
					objPricebookEntryCust.PrecioSinIva__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).PrecioSinIva;
					objPricebookEntryCust.TAM_OceanFreightUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sOceanFreightUSD;
					objPricebookEntryCust.TAM_ISANTaxTotalEmployeeMXP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sISANTaxTotalEmployeeMXP;
					objPricebookEntryCust.TAM_IVAVATMXP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dIVAVATMXP;
					objPricebookEntryCust.TAM_IVAP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).iIVAP;
					objPricebookEntryCust.TAM_VehicleExFactoryPriceUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dVehicleExFactoryPriceUSD;
					objPricebookEntryCust.TAM_LandedCostMXP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dLandedCostMXP;
					objPricebookEntryCust.TAM_InlandFreightUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sInlandFreightUSD == null ? 0.00 : Decimal.valueOf(mapWrpPricebookEntry.get(sWrpPricebookEntry).sInlandFreightUSD); //VALIDAR;	;				
					objPricebookEntryCust.TAM_OneExFactPriceAdjustmentFactorMXP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sOneExFactPriceAdjustmentFactorMXP;
					objPricebookEntryCust.TAM_ISANTaxTotalMXP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sISANTaxTotalMXP;
					objPricebookEntryCust.TAM_IVAVATEmployeeMXP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dIVAVATEmployeeMXP;
					objPricebookEntryCust.TAM_MixPercentage__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).iMixPercentage;
					objPricebookEntryCust.TAM_FreightInsuranceUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dFreightInsuranceUSD;
					objPricebookEntryCust.TAM_MexicoLocalCostsMXP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dMexicoLocalCostsMXP;
					objPricebookEntryCust.TAM_MarineInsuranceP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sMarineInsuranceP;
					objPricebookEntryCust.TAM_PDIPDSMXP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sPDIPDSMXP;
					objPricebookEntryCust.TAM_RetailPriceUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dRetailPriceUSD;
					objPricebookEntryCust.PrecioDealer__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dDealerCostMXP;
					
					System.debug('En mapWrpPricebookEntry objPricebookEntryCust: ' + objPricebookEntryCust);
					//Agregalo al mapa de objPricebookEntryCust
					mapPricebookEntryUps.put(sIdProdIdCustListPrice, objPricebookEntryCust);									
					
					//Para el registro relaciopado
					objTAMCamposRelEntradaListaPrecios.TAM_ModId__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sTAM_ModId;
					objTAMCamposRelEntradaListaPrecios.TAM_MarineInsuranceUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dMarineInsuranceUSD;
					objTAMCamposRelEntradaListaPrecios.TAM_DealerCostUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dDealerCostUSD;										
					objTAMCamposRelEntradaListaPrecios.TAM_ExFactorywFastPricingUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dExFactorywFastPricingUSD;
					objTAMCamposRelEntradaListaPrecios.TAM_MSRPwoIVAEmployeeMXP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dMSRPwoIVAEmployeeMXP;
					objTAMCamposRelEntradaListaPrecios.TAM_ApplicableAmountMXP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sApplicableAmountMXP == null ? 0.00 : Decimal.valueOf(mapWrpPricebookEntry.get(sWrpPricebookEntry).sApplicableAmountMXP); //VALIDAR;
					objTAMCamposRelEntradaListaPrecios.TAM_PDIPDSEmployeeMXP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).iPDIPDSEmployeeMXP;	
					objTAMCamposRelEntradaListaPrecios.TAM_MSRPwoIVAISANUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dMSRPwoIVAISANUSD;	
					objTAMCamposRelEntradaListaPrecios.TAM_FixedAmountMXP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dFixedAmountMXP;	
					objTAMCamposRelEntradaListaPrecios.TAM_MSRPwoIVAISANEmployeeMXP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dMSRPwoIVAISANEmployeeMXP;	
					objTAMCamposRelEntradaListaPrecios.TAM_ProdMth__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sProdMth;	
					objTAMCamposRelEntradaListaPrecios.TAM_FileName__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sFileName;	
					objTAMCamposRelEntradaListaPrecios.TAM_M3USD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dM3USD;	
					objTAMCamposRelEntradaListaPrecios.TAM_FreightInsuranceMXP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dFreightInsuranceMXP;
					objTAMCamposRelEntradaListaPrecios.TAM_IVAPEmployeeMXP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).iIVAPEmployeeMXP;
					objTAMCamposRelEntradaListaPrecios.TAM_CIFtoTMEXMXP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dCIFtoTMEXMXP;
					objTAMCamposRelEntradaListaPrecios.TAM_ModName__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sModName;
					objTAMCamposRelEntradaListaPrecios.TAM_MSRPwoIVAMXP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dMSRPwoIVAMXP;
					objTAMCamposRelEntradaListaPrecios.TAM_CIFtoTMEXUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dCIFtoTMEXUSD;
					objTAMCamposRelEntradaListaPrecios.TAM_DealerCostEmployeeMXP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dDealerCostEmployeeMXP;
					objTAMCamposRelEntradaListaPrecios.TAM_MSRPwoIVAISANMXP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dMSRPwoIVAISANMXP;
					objTAMCamposRelEntradaListaPrecios.TAM_WharfageANDHandlingUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).iWharfageANDHandlingUSD == null ? 0.00 : Decimal.valueOf(mapWrpPricebookEntry.get(sWrpPricebookEntry).iWharfageANDHandlingUSD); //VALIDAR;
					objTAMCamposRelEntradaListaPrecios.TAM_DTAP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dDTAP;
					objTAMCamposRelEntradaListaPrecios.TAM_DealerCostMXP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dDealerCostMXP;
					objTAMCamposRelEntradaListaPrecios.TAM_AllinrateUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dAllinrateUSD;
					objTAMCamposRelEntradaListaPrecios.TAM_PricingFXRatesMXP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).iPricingFXRatesMXP;
					objTAMCamposRelEntradaListaPrecios.TAM_Source__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sSource;
					objTAMCamposRelEntradaListaPrecios.TAM_ExFactoryPricewithoptionsUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dExFactoryPricewithoptionsUSD;
					objTAMCamposRelEntradaListaPrecios.TAM_DocksidePreparationUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sDocksidePreparationUSD == null ? 0.00 : Decimal.valueOf(mapWrpPricebookEntry.get(sWrpPricebookEntry).sDocksidePreparationUSD); //VALIDAR;
					objTAMCamposRelEntradaListaPrecios.TAM_DTAUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dDTAUSD;
					objTAMCamposRelEntradaListaPrecios.TAM_MSRPUSD__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dMSRPUSD;
					objTAMCamposRelEntradaListaPrecios.TAM_FreightInsuranceEmployeeMXP__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).dFreightInsuranceEmployeeMXP;

					objTAMCamposRelEntradaListaPrecios.TAM_CuotaPublicidad__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sCuotaPublicidad == null ? 0.00 : Decimal.valueOf(mapWrpPricebookEntry.get(sWrpPricebookEntry).sCuotaPublicidad); //VALIDAR;
					objTAMCamposRelEntradaListaPrecios.TAM_CuotaAsociacionFundacion__c = mapWrpPricebookEntry.get(sWrpPricebookEntry).sCuotaAsociacionFundacion == null ? 0.00 : Decimal.valueOf(mapWrpPricebookEntry.get(sWrpPricebookEntry).sCuotaAsociacionFundacion); //VALIDAR;

					objTAMCamposRelEntradaListaPrecios.TAM_IdExterno__c = sIdProdIdCustListPrice;
					System.debug('En mapWrpPricebookEntry objTAMCamposRelEntradaListaPrecios: ' + objTAMCamposRelEntradaListaPrecios);
					//Agregalo al mapa de mapCampRelPricebookEntryPaso
					mapCampRelPricebookEntryPaso.put(sIdProdIdCustListPrice, objTAMCamposRelEntradaListaPrecios);
					
					System.debug('En mapWrpPricebookEntry sIdProdIdCustListPrice: ' + sIdProdIdCustListPrice);								
				}//Fin si mapProduct2Fin.containsKey(lWrpPricebookEntry.get(0)) && mapPricebook2Fin.containsKey(lWrpPricebookEntry.get(1))
	    	}//Fin del for para sWrpPricebook

			System.debug('En mapWrpPricebookEntry mapPricebookEntryStd: ' + mapPricebookEntryStd);
			//Ve si tiene algo la lista de mapPricebookEntryStd
	    	if (!mapPricebookEntryStd.isEmpty()){
	    		List<Database.UpsertResult> lDtbUpsRes = Database.upsert(mapPricebookEntryStd.values(), PricebookEntry.id, false);
	    		//Ve si hubo errores
	    		for (Database.UpsertResult objDtbUpsRes : lDtbUpsRes){
	    			if (!objDtbUpsRes.isSuccess())
	    				System.debug('Error a la hora de actualizar la lista de precios estandard: ' + objDtbUpsRes.getErrors()[0].getMessage());
	    		}//Fin del for para lDtbUpsRes    		
	    	} //Fin si !mapWrpProducto.isEmpty()
			System.debug('En mapWrpPricebookEntry mapPricebookEntryStd: ' + mapPricebookEntryStd);

			System.debug('En mapWrpPricebookEntry mapPricebookEntryUps: ' + mapPricebookEntryUps);
			Set<String> setIdmapPricebookEntryUps = new Set<String>(); 			
			//Ve si tiene algo la lista de mapPricebookEntryStd
	    	if (!mapPricebookEntryUps.isEmpty()){
	    		List<Database.UpsertResult> lDtbUpsRes = Database.upsert(mapPricebookEntryUps.values(), PricebookEntry.id, false);
	    		//Ve si hubo errores
	    		for (Database.UpsertResult objDtbUpsRes : lDtbUpsRes){
	    			if (!objDtbUpsRes.isSuccess())
	    				System.debug('Error a la hora de actualizar la lista de precios customizada: ' + objDtbUpsRes.getErrors()[0].getMessage());
	    			if (objDtbUpsRes.isSuccess())
	    				setIdmapPricebookEntryUps.add(objDtbUpsRes.getId());	    				
	    		}//Fin del for para lDtbUpsRes    		
	    	} //Fin si !mapWrpProducto.isEmpty()
			System.debug('En mapWrpPricebookEntry setIdmapPricebookEntryUps: ' + setIdmapPricebookEntryUps);	    				
			System.debug('En mapWrpPricebookEntry mapPricebookEntryUps: ' + mapPricebookEntryUps.KeySet());
			System.debug('En mapWrpPricebookEntry mapPricebookEntryUps: ' + mapPricebookEntryUps.Values());
			
			//Consulta los ID's de los reg creados en  setIdmapPricebookEntryUps y obten e ID EXTERNO
			for (PricebookEntry objPricebookEntry : [Select id, IdExterno__c From PricebookEntry Where Id IN: setIdmapPricebookEntryUps]){
				//Busca en el mapa de mapCampRelPricebookEntryUps si eciste el objPricebookEntry.IdExterno__c
				if (mapCampRelPricebookEntryPaso.containsKey(objPricebookEntry.IdExterno__c)){
					TAM_CamposRelEntradaListaPrecios__c objPaso = mapCampRelPricebookEntryPaso.get(objPricebookEntry.IdExterno__c);
					//incializa el canpo de TAM_EntradaListaPrecios__c
					objPaso.Name = objPricebookEntry.IdExterno__c;
					objPaso.TAM_EntradaCatalogoListaPrecios__c = objPricebookEntry.id; 
					mapCampRelPricebookEntryUps.put(objPricebookEntry.IdExterno__c, objPaso);
				}
			}
			
			System.debug('En mapWrpPricebookEntry mapCampRelPricebookEntryUps: ' + mapCampRelPricebookEntryUps);
			Set<String> setIdmapCampRelPricebookEntryUps = new Set<String>(); 			
			//Ve si tiene algo la lista de mapPricebookEntryStd
	    	if (!mapCampRelPricebookEntryUps.isEmpty()){
	    		List<Database.UpsertResult> lDtbUpsRes = Database.upsert(mapCampRelPricebookEntryUps.values(), TAM_CamposRelEntradaListaPrecios__c.TAM_IdExterno__c, false);
	    		//Ve si hubo errores
	    		for (Database.UpsertResult objDtbUpsRes : lDtbUpsRes){
	    			if (!objDtbUpsRes.isSuccess())
	    				System.debug('Error a la hora de actualizar los campos relacionados a la lista de precios customizada: ' + objDtbUpsRes.getErrors()[0].getMessage());
	    			if (objDtbUpsRes.isSuccess())
	    				setIdmapCampRelPricebookEntryUps.add(objDtbUpsRes.getId());	    				
	    		}//Fin del for para lDtbUpsRes    		
	    	} //Fin si !mapWrpProducto.isEmpty()
			System.debug('En mapWrpPricebookEntry setIdmapCampRelPricebookEntryUps: ' + setIdmapCampRelPricebookEntryUps);	    				
			System.debug('En mapWrpPricebookEntry mapCampRelPricebookEntryUps: ' + mapCampRelPricebookEntryUps.KeySet());
			System.debug('En mapWrpPricebookEntry mapCampRelPricebookEntryUps: ' + mapCampRelPricebookEntryUps.Values());

			//Finalmente actualiza los productos en la el objeto de VehiculoSIV__c			
			//Select v., v., v., v., v., v., v.Descuento__c, v. From VehiculoSIV__c v
	    	for (TAM_CatalogoProductos__c objTAM_CatalogoProductos : itemsNew){
				System.debug('EN beforeInsert objTAM_CatalogoProductos: ' + objTAM_CatalogoProductos);
							
				//Ve si el producto tiene los datos que se requieren para la llave externa
				if (objTAM_CatalogoProductos.IdExterno__c != null && objTAM_CatalogoProductos.IdExterno__c != ''){
					
					//Formatea las fechas
					String sInicioVigencia = ConvierteFecha(objTAM_CatalogoProductos.InicioVigencia__c);
					String sFinVigencia = ConvierteFecha(objTAM_CatalogoProductos.FinVigencia__c);
					String sNombre = objTAM_CatalogoProductos.Serie__c + ' ' + objTAM_CatalogoProductos.Version__c; 
					String sIdExternoProdIdExtListPrecios = objTAM_CatalogoProductos.IdExterno__c + ',' + objTAM_CatalogoProductos.IdExternoListaPrecios__c;
					String sPrecioSinIva = objTAM_CatalogoProductos.PrecioSinIva__c != null ? objTAM_CatalogoProductos.PrecioSinIva__c : '0.00';
					sPrecioSinIva = sPrecioSinIva.replace(',',''); 
					String sPrecioPublico = objTAM_CatalogoProductos.PrecioPublico__c != null ? objTAM_CatalogoProductos.PrecioPublico__c : '0.00';
					sPrecioPublico = sPrecioPublico.replace(',','');
					String sPrecioTotalEmpleado = objTAM_CatalogoProductos.PrecioTotalEmpleado__c != null ? objTAM_CatalogoProductos.PrecioTotalEmpleado__c : '0.00';
					sPrecioTotalEmpleado = sPrecioTotalEmpleado.replace(',','');

					Decimal dPrecioSinIvaPaso = Decimal.valueOf((objTAM_CatalogoProductos.PrecioPublico__c != null ? objTAM_CatalogoProductos.PrecioPublico__c : '0.00')) * .16;
					Decimal dPrecioSinIvaFinal = Decimal.valueOf((objTAM_CatalogoProductos.PrecioPublico__c != null ? objTAM_CatalogoProductos.PrecioPublico__c : '0.00')) - dPrecioSinIvaPaso;
					System.debug('EN beforeInsert sPrecioSinIva: ' + sPrecioSinIva + ' sPrecioPublico: ' + sPrecioPublico + ' sPrecioTotalEmpleado: ' + sPrecioTotalEmpleado + ' dPrecioSinIvaFinal: ' + dPrecioSinIvaFinal);
					
					//Toma el objeto el propducto y saca los datos Product2
	    			mapVehiculoSIV.put(objTAM_CatalogoProductos.IdExterno__c, new VehiculoSIV__c(
	    					Id_Externo__c = objTAM_CatalogoProductos.IdExterno__c,
	    					Name = sNombre,
	    					AnoModelo__c = objTAM_CatalogoProductos.AnioModelo__c,
	    					InicioVigencia__c = Date.valueOf(sInicioVigencia),
	    					FinVigencia__c = Date.valueOf(sFinVigencia),
	    					PrecioPublico__c = Decimal.valueOf(sPrecioPublico),
	    					PrecioTotalEmpleado__c = Decimal.valueOf(sPrecioTotalEmpleado),
	    					Modelo__c = mapProduct2Fin.get(objTAM_CatalogoProductos.IdExterno__c).id
	    				)
	    			);
					
					//Recorre el mapa de mapCapturaIVA y crea los objeto del tipo TAM_IvaAplicadoVehiculos__c
					for (String sIvaName : mapCapturaIVA.KeySet()){
						String sIdExternoNameIva = objTAM_CatalogoProductos.IdExterno__c + '-' + sIvaName;
						//Agrega el registro del Iva al mapa de mapTAMIvaAplicadoVehiculos
						mapTAMIvaAplicadoVehiculos.put(sIdExternoNameIva, new TAM_IvaAplicadoVehiculos__c(
								TAM_IdExterno__c = sIdExternoNameIva, 
								Name = sIdExternoNameIva,
								TAM_Activo__c = mapCapturaIVA.get(sIvaName).ActivoIVA__c,
								TAM_PrecioSinIva__c = dPrecioSinIvaFinal,
								TAM_Iva__c = mapCapturaIVA.get(sIvaName).IVA__c
							)
						); 
					}//Fin del for para mapCapturaIVA
					
				}//Fin del si objTAM_CatalogoProductos.IdExterno__c != null && objTAM_CatalogoProductos.IdExterno__c != ''	
			}//Fin del for para itemsNew
			
			//Ve si tiene algo el mapa de mapVehiculoSIV
			System.debug('En mapWrpPricebookEntry mapVehiculoSIV: ' + mapVehiculoSIV);
			Set<String> setIdmapVehiculoSIV = new Set<String>(); 		
			Map<String, String> mapVehiculoSIVUpd = new Map<String, String>(); 	
			//Ve si tiene algo la lista de mapPricebookEntryStd
	    	if (!mapVehiculoSIV.isEmpty()){
	    		List<Database.UpsertResult> lDtbUpsRes = Database.upsert(mapVehiculoSIV.values(), VehiculoSIV__c.Id_Externo__c, false);
	    		//Ve si hubo errores
	    		for (Database.UpsertResult objDtbUpsRes : lDtbUpsRes){
	    			if (!objDtbUpsRes.isSuccess())
	    				System.debug('Error a la hora de actualizar el objeto de VehiculoSIV__c: ' + objDtbUpsRes.getErrors()[0].getMessage());
	    			if (objDtbUpsRes.isSuccess())
	    				setIdmapVehiculoSIV.add(objDtbUpsRes.getId());	    				
	    		}//Fin del for para lDtbUpsRes    		
	    	} //Fin si !mapWrpProducto.isEmpty()
	    	for (VehiculoSIV__c objVehiculoSIV : [Select id, Id_Externo__c From VehiculoSIV__c Where id IN :setIdmapVehiculoSIV]) {
	    		mapVehiculoSIVUpd.put(objVehiculoSIV.Id_Externo__c, objVehiculoSIV.id);
	    	}
			System.debug('En actualizaListaPrecios setIdmapVehiculoSIV: ' + setIdmapVehiculoSIV);	    				
			System.debug('En actualizaListaPrecios mapVehiculoSIV: ' + mapVehiculoSIV.KeySet());
			System.debug('En actualizaListaPrecios mapVehiculoSIV: ' + mapVehiculoSIV.Values());
			System.debug('En actualizaListaPrecios mapVehiculoSIV: ' + mapVehiculoSIVUpd);
			
			List<TAM_IvaAplicadoVehiculos__c> lTAM_IvaAplicadoVehiculosUps = new List<TAM_IvaAplicadoVehiculos__c>();
			//Recorre el mapa de mapTAMIvaAplicadoVehiculos y actualiza la lista final de reg TAM_IvaAplicadoVehiculos__c
			for (String sIdExternoNameIva : mapTAMIvaAplicadoVehiculos.KeySet()){
				//Quita del nombre la pruimera parte hasta el guion 
				String sIdExt = sIdExternoNameIva.contains('-') ? sIdExternoNameIva.substring(0, sIdExternoNameIva.indexOf('-')) : null;
				//Ve si tiene algo sIdExt
				if (sIdExt != null){
					//Ve si sIdExt existe en el mapa de mapVehiculoSIVUpd
					if (mapVehiculoSIVUpd.containsKey(sIdExt)){
						//Agrega a la lista de lTAM_IvaAplicadoVehiculosUps el nuevo objeto 
						TAM_IvaAplicadoVehiculos__c objTAM_IvaAplicadoVehiculosPaso = mapTAMIvaAplicadoVehiculos.get(sIdExternoNameIva);  
						//Inicializa el campo TAM_PrecioVehiculos__c 
						objTAM_IvaAplicadoVehiculosPaso.TAM_PrecioVehiculos__c = mapVehiculoSIVUpd.get(sIdExt); 
						//Agregalo a la lista de lTAM_IvaAplicadoVehiculosUps
						lTAM_IvaAplicadoVehiculosUps.add(objTAM_IvaAplicadoVehiculosPaso);
					}//Fin si mapVehiculoSIVUpd.containsKey(sIdExt)
				} //Fin si sIdExt != null
			}//Fin del for para mapTAMIvaAplicadoVehiculos
			
			System.debug('En actualizaListaPrecios lTAM_IvaAplicadoVehiculosUps: ' + lTAM_IvaAplicadoVehiculosUps);			
			//Ve si tiene algo la lista de lTAM_IvaAplicadoVehiculosUps y actualiza los valores
	    	if (!lTAM_IvaAplicadoVehiculosUps.isEmpty()){
	    		List<Database.UpsertResult> lDtbUpsRes = Database.upsert(lTAM_IvaAplicadoVehiculosUps, TAM_IvaAplicadoVehiculos__c.TAM_IdExterno__c, false);
	    		//Ve si hubo errores
	    		for (Database.UpsertResult objDtbUpsRes : lDtbUpsRes){
	    			if (!objDtbUpsRes.isSuccess())
	    				System.debug('Error a la hora de actualizar el objeto de TAM_IvaAplicadoVehiculos__c: ' + objDtbUpsRes.getErrors()[0].getMessage());
	    			if (objDtbUpsRes.isSuccess()){
	    				System.debug('ID  del objeto de TAM_IvaAplicadoVehiculos__c: ' + objDtbUpsRes.getId());
	    				setIdmapVehiculoSIV.add(objDtbUpsRes.getId());
	    			}	    				
	    		}//Fin del for para lDtbUpsRes    		
	    	} //Fin si !mapWrpProducto.isEmpty()
		
			//Ejecuta el Rollback si hay error en algun lugar de todo esto
			//Database.rollback(sp);
					
		}catch(Exception ex){
			System.debug('En mapWrpPricebookEntry ERROR: ' + ex.getMessage() + ' ' + ex.getLineNumber());			
			//Ejecuta el Rollback si hay error en algun lugar de todo esto
			Database.rollback(sp);
		}
		
    }
    
    private String ConvierteFecha(String sFecha){
    	System.debug('Entro a ConvierteFecha sFecha: ' + sFecha);
    	String sFechaPaso;
    	
    	String sDia;
    	String sMes;
    	String sAnio;
    	
    	//Ve si tiene algo la fecha sFecha
    	if (sFecha != null && sFecha != ''){
    		if (sFecha.contains('-'))
    			if ( sFecha.indexOf('-') > 2 )
    				return sFecha;
    		if (sFecha.contains('/')){
				sDia = sFecha.substring(0, 2);
				sDia = Integer.valueOf(sDia) < 10 ? '0' + Integer.valueOf(sDia) : sDia;
	    		System.debug('Entro a ConvierteFecha sDia: ' + sDia);			 
				sMes = sFecha.substring(3, 5);
				sMes = Integer.valueOf(sMes) < 10 ? '0' + Integer.valueOf(sMes)  : sMes;
	    		System.debug('Entro a ConvierteFecha sMes: ' + sMes);						
				sAnio = sFecha.substring(6, 10);
	    		System.debug('En ConvierteFecha sDia: ' + sDia + ' sMes: ' + sMes + ' sAnio: ' + sAnio);
				//Ya tienes los datos de la fecha entonces creala con el formato adecuado
				sFechaPaso = sAnio + '-' + sMes + '-' + sDia;
    		}//Fin si sFecha.indexOf('/') == 2
    	}//Fin si sFecha != null && sFecha != ''
    	System.debug('Entro a ConvierteFecha sFechaPaso: ' + sFechaPaso);
    	    	
    	return sFechaPaso;
    }
    
    
}